import React, { FC, useEffect, useState } from 'react';
import Button from '@material-ui/core/Button';
import { Grid, Typography, Hidden } from '@material-ui/core';
import { getRoles } from 'api/getRoles';
import { setRole } from 'api/setRole';
import { useHistory } from 'react-router-dom';
import { AuthRoutes } from 'api/routes';
import { choseRoleStyle } from './ChoseRole.style';

export const ChoseRole: FC = () => {
  const classes = choseRoleStyle();

  const history = useHistory();
  const [userRoles, setUserRoles] = useState<string[]>(['']);

  const choseAndForward = (role: string): void => {
    setRole(role).then(() =>
      history.push(`${AuthRoutes.dashboard}${AuthRoutes.home}`),
    );
  };

  useEffect(() => {
    getRoles().then((fetchedRoles) => setUserRoles(fetchedRoles));
  }, []);

  return (
    <div data-testid="ChoseRole">
      {userRoles ? (
        userRoles.map((role) => (
          <Button
            variant="outlined"
            fullWidth
            color="default"
            key={role}
            onClick={() => choseAndForward(role)}
            className={classes.paddingTopKlein}
          >
            {role}
          </Button>
        ))
      ) : (
        <h1>No roles were returned.</h1>
      )}
    </div>
  );
};
